#ifndef XGAMEDEFINES_H_
#define XGAMEDEFINES_H_

#define GAME_VERSION	1003

#define EDITINGBEATMARKERS	0
#define MOVINGPLAYERMODEL	0

#define BB_PENDINGACHIEVEMENTS_MAX	 5

#define BB_ENEMIES_MAX	13

#define BB_FREEPLAY_SCROLLTIME	0.3f
#define BB_FREEPLAY_SONGCOUNT	9

#define	BB_VERSUS_ANIMATION_TIME		   0.4f
#define BB_VERSUS_MINIMUM_TIME			2000
#define BB_VERSUS_VS_LEFT				 260.0f
#define BB_VERSUS_VS_START				 800.0f
#define BB_VERSUS_VS_END				  90.0f
#define BB_VERSUS_PLAYERPORTRAIT_START	-400.0f
#define BB_VERSUS_PLAYERPORTRAIT_END	  20.0f
#define BB_VERSUS_PLAYERPORTRAIT_TOP	  35.0f
#define BB_VERSUS_ENEMYPORTRAIT_START	1050.0f
#define BB_VERSUS_ENEMYPORTRAIT_END		 512.0f
#define BB_VERSUS_ENEMYPORTRAIT_TOP		   0.0f
#define	BB_VERSUS_PLAYERNAME_CENTER		 228.0f
#define BB_VERSUS_PLAYERNAME_TOP		 100.0f
#define BB_VERSUS_ENEMYNAME_CENTER		 820.0f
#define BB_VERSUS_ENEMYNAME_TOP			 680.0f
#define BB_VERSUS_NAME_MAXWIDTH			 340.0f
#define BB_VERSUS_SONGNAME_RIGHT		1016.0f
#define BB_VERSUS_SONGNAME_TOP			   8.0f
#define BB_VERSUS_ARTISTNAME_TOP		  37.0f

#define BB_PIECECOLORS_MAX	7
#define BB_BLOCKOFFSET		40
#define BB_LARGEBLOCKOFFSET	50
#define BB_GROWNBLOCKOFFSET	111

#define BB_BLOCKGLOWOFFSET	7

#define BB_BEATMARKERS_MAX		   8
#define BB_BEATMARKERX			   5.0f
#define BB_BEATMARKERY			-119.0f
#define BB_BEATMARKERDIMMERX	 208.0f
#define BB_BEATMARKERDIMMERY	  84.0f
#define BB_BEATMARKERHITZONEX	 379.0f
#define BB_BEATMARKERHITZONEY	 255.0f
#define BB_BEATMARKERMAXSIZE	1024.0f
#define	BB_BEATMARKERMINSIZE	 270.0f
#define BB_BEATMARKEROFFSETX	 377.0f
#define BB_BEATMARKEROFFSETY	 377.0f

#define BB_FIELDX					194
#define BB_FIELDY					 70
#define BB_FIELDWIDTH				 12
#define BB_FIELDHEIGHT				  6
#define BB_FIELD_FLASHWHITE			  0.15f
#define BB_FIELD_UNFLASHWHITE		  0.25f
#define BB_FIELD_ROTATETIME			  0.10f
#define BB_FIELD_PIECESTARTX		  3
#define BB_FIELD_PIECESTARTY		 -2

#define BB_FIELD_COLORTRANS_1ST		300
#define BB_FIELD_COLORTRANS_UN1ST	600
#define BB_FIELD_COLORTRANS_2ND		900
#define BB_FIELD_COLORTRANS_UN2ND	1200
#define BB_FIELD_COLORTRANS_3RD		1500
#define BB_FIELD_COLORTRANS_UN3RD	1800
#define BB_FIELD_COLORTRANS_4TH		2100
#define BB_FIELD_COLORTRANS_UN4TH	2400
#define BB_FIELD_COLORTRANS_5TH		2600
#define BB_FIELD_COLORTRANS_UN5TH	2800
#define BB_FIELD_COLORTRANS_6TH		3000
#define BB_FIELD_COLORTRANS_UN6TH	3200
#define BB_FIELD_COLORTRANS_7TH		3400
#define BB_FIELD_COLORTRANS_UN7TH	3600
#define BB_FIELD_COLORTRANS_8TH		3700
#define BB_FIELD_COLORTRANS_UN8TH	3800
#define BB_FIELD_COLORTRANS_9TH		3900
#define BB_FIELD_COLORTRANS_UN9TH	4000
#define BB_FIELD_COLORTRANS_10TH	4100
#define BB_FIELD_COLORTRANS_TOTAL	BB_FIELD_COLORTRANS_10TH

#define BB_BUILDOVERLAYX	195
#define BB_BUILDOVERLAYY	195

#define BB_BUILDOVERLAYWHITEX	196
#define BB_BUILDOVERLAYWHITEY	195

#define BB_PLACEFAILWARNINGX	195
#define BB_PLACEFAILWARNINGY	195

#define BB_PIECEMINCOLUMNID	-1
#define BB_PIECEMAXCOLUMNID	 1
#define BB_PIECEMINROWID	-1
#define BB_PIECEMAXROWID	 1

#define BB_PIECESTARTX	497
#define BB_PIECESTARTY	373

#define BB_PIECE_ANIMBUILDFAILED		 0.10f
#define BB_PIECE_ANIMBUILDSUCCESSFUL	 0.20f
#define BB_PIECE_ANIMBUILDGROW			 0.06f
#define	BB_PIECE_NEWBLOCKSCALEINTIME	 0.15f
#define	BB_PIECE_NEWBLOCKSCALEDOWNTIME	-0.10f

#define BB_BLOCKADDED_TIME	0.05f

#define BB_BLOCKTOANIMATEDBLOCKOFFSETX	0
#define BB_BLOCKTOANIMATEDBLOCKOFFSETY	0

#define BB_COUNTDOWN_LEFT	266
#define BB_COUNTDOWN_TOP	128

#define BB_OVERFLOW_LEFT	769
#define BB_OVERFLOW_TOP		103

#define BB_HITTIME_LEFT		316
#define BB_HITTIME_TOP		150
#define BB_HITTIME_WIDTH	392
#define BB_HITTIME_HEIGHT	 64

#define BB_MULTIPLIER_LEFT		195
#define BB_MULTIPLIER_TOP		196

#define BB_CROWDBAR_ARROW_DISTANCE	328.0f
#define BB_CROWDBAR_ARROW_CENTERX	323.5f
#define BB_CROWDBAR_ARROW_CENTERY	323.5f
#define BB_CROWDBAR_PLAYER_ANGLE	214
#define BB_CROWDBAR_ENEMY_ANGLE		34

#define BB_PLAYER_CHARGE_BG_TOP		652
#define BB_PLAYER_CHARGE1_LEFT		2
#define BB_PLAYER_CHARGE1_TOP		BB_PLAYER_CHARGE_BG_TOP + 81
#define BB_PLAYER_CHARGE2_LEFT		12
#define BB_PLAYER_CHARGE2_TOP		BB_PLAYER_CHARGE_BG_TOP + 60
#define BB_PLAYER_CHARGE3_LEFT		26
#define BB_PLAYER_CHARGE3_TOP		BB_PLAYER_CHARGE_BG_TOP + 32
#define BB_PLAYER_CHARGE4_LEFT		50
#define BB_PLAYER_CHARGE4_TOP		BB_PLAYER_CHARGE_BG_TOP + 6
#define BB_PLAYER_NAME_BG_LEFT		85
#define BB_PLAYER_NAME_BG_TOP		BB_PLAYER_CHARGE_BG_TOP + 52
#define BB_PLAYER_NAME_LEFT			BB_PLAYER_NAME_BG_LEFT - 2
#define BB_PLAYER_NAME_TOP			BB_PLAYER_NAME_BG_TOP + 30
#define BB_PLAYER_RANK_OFFSETY		10

#define BB_ENEMY_CHARGE_BG_LEFT	953
#define BB_ENEMY_CHARGE_LEFT	BB_ENEMY_CHARGE_BG_LEFT + 23
#define BB_ENEMY_CHARGE_TOP		8
#define BB_ENEMY_NAME_SPACING	14
#define BB_ENEMY_NAME_TOP		2
#define BB_ENEMY_RANK_OFFSETY	BB_PLAYER_RANK_OFFSETY

#define BB_RANK_NAME_SPACING	3

#define	BB_CHARGE_FLASH_TOTAL	1050
#define	BB_CHARGE_FLASH1		150
#define	BB_CHARGE_UNFLASH1		300
#define	BB_CHARGE_FLASH2		450
#define	BB_CHARGE_UNFLASH2		600
#define	BB_CHARGE_FLASH3		750
#define	BB_CHARGE_UNFLASH3		900

#define BB_TIME_CENTER	512
#define BB_TIME_TOP		-1

#define BB_TUT_TOPKEY_LEFT		493
#define BB_TUT_TOPKEY_TOP		552
#define BB_TUT_LEFTKEY_LEFT		433
#define BB_TUT_LEFTKEY_TOP		612
#define BB_TUT_BOTTOMKEY_LEFT	493
#define BB_TUT_BOTTOMKEY_TOP	612
#define BB_TUT_RIGHTKEY_LEFT	553
#define BB_TUT_RIGHTKEY_TOP		612
#define BB_TUT_SOLOKEY_CENTER	357
#define BB_TUT_SOLOKEY_TOP		612
#define BB_TUT_BLANKKEY_OFFSETX	28
#define BB_TUT_BLANKKEY_OFFSETY	10

#define BB_GRAVITY	300

#define BB_MAXTRACKSINSONG	6

#define BB_SCORE_PIECECOMPLETED			1000
#define BB_SCORE_PIECEPUSHEDDOWN		  50
#define BB_SCORE_BLOCKSCLEAREDMULTIPLIER  10

#define BB_CURRENCY_BRONZEMEDAL	  25
#define BB_CURRENCY_SILVERMEDAL	  50
#define BB_CURRENCY_GOLDMEDAL	 100
#define BB_CURRENCY_ACHIEVEMENT	  50

#define BB_CROWDSHIFT_BLOCKSCLEARED				-0.01f

#define BB_CROWDSHIFT_FAILEDTOADDBLOCK_BEGINNER		0.02f
#define BB_CROWDSHIFT_FAILEDTOADDBLOCK_NOVICE		0.03f
#define BB_CROWDSHIFT_FAILEDTOADDBLOCK_EXPERT		0.05f

#define BB_CROWDSHIFT_MISSEDBEAT_BEGINNER			0.005f
#define BB_CROWDSHIFT_MISSEDBEAT_NOVICE				0.01f
#define BB_CROWDSHIFT_MISSEDBEAT_EXPERT				0.03f

#define BB_CROWDSHIFT_MISSEDCOMBO_BEGINNER			0.02f
#define BB_CROWDSHIFT_MISSEDCOMBO_NOVICE			0.04f
#define BB_CROWDSHIFT_MISSEDCOMBO_EXPERT			0.05f

#define BB_OVERFLOW_MAX	10

#define BB_HITTIME1		250
#define BB_HITTIME2		150
#define BB_HITTIME3		100
#define BB_HITTIME4		 50
#define BB_HITTIME5		 25

#define BB_HITTIME_SCALEIN	 250
#define BB_HITTIME_GROW		 750
#define BB_HITTIME_SCALEOUT	1000

#define BB_PIECEDROP_INTERVAL	50

#define BB_PLAYERMOVE_APPLAUSEDELAY	1.5

#define BB_BLOCKSCLEARED_TEXT_LEFT		128
#define BB_BLOCKSCLEARED_TEXT_TOP		130
#define BB_BLOCKSCLEARED_TEXT_ROTATION	 13
#define BB_BLOCKSCLEARED_LEFT			324
#define BB_BLOCKSCLEARED_TOP			108
#define BB_BLOCKSCLEARED_SIZEX			602
#define BB_BLOCKSCLEARED_SIZEY			185
#define BB_BLOCKSCLEARED_DESC_LEFT		188
#define BB_BLOCKSCLEARED_DESC_TOP		540
#define BB_BLOCKSCLEARED_DESC_SIZEX		698
#define BB_BLOCKSCLEARED_DESC_SIZEY		125
#define BB_BLOCKSCLEARED_GROWTIME		  0.15
#define BB_BLOCKSCLEARED_HANGTIME		  0.90
#define BB_BLOCKSCLEARED_HANGTIME_CHAL	  2 * BB_BLOCKSCLEARED_HANGTIME
#define BB_BLOCKSCLEARED_FADETIME		  0.15

#define BB_COMBO_TEXT_LEFT		128
#define BB_COMBO_TEXT_TOP		130
#define BB_COMBO_TEXT_ROTATION	 13
#define BB_COMBO_LEFT			324
#define BB_COMBO_TOP			108
#define BB_COMBO_SIZEX			602
#define BB_COMBO_SIZEY			185
#define BB_COMBO_DESC_LEFT		188
#define BB_COMBO_DESC_TOP		540
#define BB_COMBO_DESC_SIZEX		698
#define BB_COMBO_DESC_SIZEY		125
#define BB_COMBO_GROWTIME		BB_BLOCKSCLEARED_GROWTIME
#define BB_COMBO_HANGTIME		BB_BLOCKSCLEARED_HANGTIME_CHAL
#define BB_COMBO_FADETIME		BB_BLOCKSCLEARED_FADETIME
#define BB_COMBO_TOTALTIME		BB_COMBO_GROWTIME + BB_COMBO_HANGTIME + BB_COMBO_FADETIME

#define BB_ACHIEVEMENT_TITLEHEIGHT		   20
#define BB_ACHIEVEMENT_TITLESCALE		    0.8
#define BB_ACHIEVEMENT_TITLEX			(1024 - 8)
#define BB_ACHIEVEMENT_ICONSIZE			   64
#define BB_ACHIEVEMENT_ICONX			(BB_ACHIEVEMENT_TITLEX - BB_ACHIEVEMENT_ICONSIZE)
#define BB_ACHIEVEMENT_TITLEY			(BB_ACHIEVEMENT_ICONSIZE + 4)
#define BB_ACHIEVEMENT_HEIGHT			(   8 + BB_ACHIEVEMENT_TITLEHEIGHT + 4 + BB_ACHIEVEMENT_ICONSIZE)
#define BB_ACHIEVEMENT_TOTALTIME		 4000
#define BB_ACHIEVEMENT_SHOWTIME			  500
#define BB_ACHIEVEMENT_HIDETIME			  400
#define BB_ACHIEVEMENT_HIDESTARTTIME	(BB_ACHIEVEMENT_TOTALTIME - BB_ACHIEVEMENT_HIDETIME)

#define BB_PREPOPUP_LINESVISIBLE			5
#define BB_PREPOPUP_MORELINESTIME			0.3
#define BB_PREPOPUP_INTROSOUNDDELAY			0.01
#define BB_PREPOPUP_INTROVOICESOUNDDELAY	1.0
#define BB_SENSEIPREPOPUP_LINESVISIBLE		8

#define BB_POSTPOPUP_CASHOFFSETX			64
#define BB_POSTPOPUP_SCORECOUNTUPTIME		1.0
#define BB_POSTPOPUP_DOMINATEDDELAY			0.65
#define BB_POSTPOPUP_DOMINATIONCOUNTUPTIME	0.75
#define BB_POSTPOPUP_DOMINATIONCOUNTUPDELAY	0.5
#define BB_POSTPOPUP_HIGHSCORESLIDETIME		0.15
#define BB_POSTPOPUP_HIGHSCORESLIDEDELAY	0.25
#define BB_POSTPOPUP_AWARDSHOWDELAY			0.5
#define BB_POSTPOPUP_ACHIEVEMENTSHOWDELAY	0.5
#define BB_POSTPOPUP_PRECASHDELAY			0.5

#define BB_PREPOPUP_FAILED_LINESVISIBLE	5

#define BB_LEVELS_MAX			44
#define BB_LEVELS_FIRSTLEVEL	"Tutorial1"

#define BB_DEFAULT_SERVERPORT	1984

#define BB_TEXTMESSAGES_MAX		5
#define BB_TEXTMESSAGES_OFFSETY	20
#define BB_TEXTMESSAGES_BUFFERX	8
#define BB_TEXTMESSAGES_BUFFERY	750
#define BB_TEXTMESSAGES_OUTPUTX	BB_TEXTMESSAGES_BUFFERX
#define BB_TEXTMESSAGES_OUTPUTY	BB_TEXTMESSAGES_BUFFERY - (BB_TEXTMESSAGES_OFFSETY + 5);

#define BB_TIME_BLOCKCLEAREDEMITTER		0.25
#define BB_TIME_CROWDBARSHIFTEMITTER	0.25
#define BB_TIME_MENUSLIDETRANSITION		0.5

#define	BB_DEPTH_BACKGROUND				-15.0
#define	BB_DEPTH_CROWDBARARROW			-14.5
#define	BB_DEPTH_FIELDBACKGROUND		-14.0
#define	BB_DEPTH_WHITEMULTIPLIER		-13.95
#define BB_DEPTH_MULTIPLIER				-13.9
#define BB_DEPTH_BUILDOVERLAY			-13.85
#define BB_DEPTH_BUILDOVERLAYWHITE		-13.80
#define BB_DEPTH_FIELDBLOCKROTATETAIL	-13.75
#define	BB_DEPTH_FIELDBLOCKS			-13.7
#define BB_DEPTH_FIELDBLOCKOVERLAY		-13.6
#define	BB_DEPTH_BEATMARKER_DIMMER		-13.5
#define BB_DEPTH_SHADOWPIECE			-13.4
#define	BB_DEPTH_FIELDBLOCKGLOW			-13.3
#define BB_DEPTH_BLOCKCLEAREDEMITTER	-13.0
#define BB_DEPTH_BLOCKADDEDEMITTER		-12.5
#define BB_DEPTH_PIECEPLACEDEMITTER		-12.0
#define	BB_DEPTH_PLAYERCHARGE_BG		-11.8
#define	BB_DEPTH_PLAYERCHARGE			-11.7
#define	BB_DEPTH_PLAYERCHARGE_OVERLAY	-11.6
#define BB_DEPTH_PLAYERNAME_BG			-11.55
#define	BB_DEPTH_PLAYERNAME				-11.5
#define	BB_DEPTH_PLAYERRANK				-11.0
#define	BB_DEPTH_ENEMYCHARGE_BG			-10.6
#define	BB_DEPTH_ENEMYCHARGE			-10.5
#define	BB_DEPTH_ENEMYCHARGE_OVERLAY	-10.4
#define	BB_DEPTH_ENEMYNAME_BG			-10.6
#define	BB_DEPTH_ENEMYNAME				-10.5
#define	BB_DEPTH_ENEMYRANK				-10.0
#define	BB_DEPTH_TIMERBACKGROUND		 -9.1
#define	BB_DEPTH_TIMER					 -9.0
#define BB_DEPTH_PLAYERMODEL			 -8.0
#define BB_DEPTH_TUTORIALDIMMER			 -7.5
#define BB_DEPTH_PIECEBLOCKS			 -7.00
#define BB_DEPTH_PIECEBLOCKOVERLAY		 -6.75
#define BB_DEPTH_PIECEBLOCKANIMATION	 -6.50
#define BB_DEPTH_PIECEBUILDARROW		 -6.25
#define BB_DEPTH_CURPIECEBLOCK			 -6.00
#define BB_DEPTH_CURPIECEBLOCKOVERLAY	 -5.75
#define BB_DEPTH_CURPIECEBUILDARROW		 -5.50
#define BB_DEPTH_BLOCKPLACEFAILWARNING	 -5.25
#define	BB_DEPTH_HITTIME				 -5.0
#define BB_DEPTH_ENEMYMODEL				 -4.0
#define BB_DEPTH_TUTKEYS				 -3.0
#define BB_DEPTH_TUTKEY_TEXT			 -2.5
#define	BB_DEPTH_BEATMARKER				 -2.0
#define	BB_DEPTH_BEATMARKER_HITZONE		 -1.75
#define	BB_DEPTH_COUNTDOWN				 -1.0
#define BB_DEPTH_COMBO					 -0.75
#define BB_DEPTH_BLOCKSCLEARED			 -0.5

#define BB_DEPTH_ACHIEVEMENT_BG			 99.0
#define BB_DEPTH_ACHIEVEMENTICON		 99.2
#define BB_DEPTH_ACHIEVEMENTTITLE		 99.5

#define BB_DEPTH_VERSUS_BACKGROUND		100.0
#define BB_DEPTH_VERSUS_VS				101.0
#define BB_DEPTH_VERSUS_PLAYERPORTRAIT	102.0
#define BB_DEPTH_VERSUS_PLAYERNAME		103.0
#define BB_DEPTH_VERSUS_ENEMYPORTRAIT	104.0
#define BB_DEPTH_VERSUS_ENEMYNAME		105.0
#define BB_DEPTH_VERSUS_SONGNAME		106.0

#define BB_STRING_UPDATEAVAILABLE	"An update is available, click Start to download it"
#define BB_STRING_UPDATECHECK		"Checking %s"
#define BB_STRING_FILESUPTODATE		"All files are up to date"

#define BB_STRING_SCORE				"%07lu"
#define BB_STRING_BATTLE_HIGHSCORE	"High Score: %lu"
#define BB_STRING_CURRENCY			"Money: %u"

#define BB_STRING_TUTORIAL_INTRO				"Greetings, mon! They call me Mas Beat. I am going to teach you how to dance like a true b-boy! To win, group as many colored blocks together as possible, and then break them to perform power moves!                                                  Ok, building blocks to the beat- each block has its own key. To build a block, press the correct key in time with the beat. The beat marker circle shrinks and turns green with every beat."
#define BB_STRING_TUTORIAL_RED					"For a red block, press %red% in time with the beat."
#define BB_STRING_TUTORIAL_RED_MISSEDBEAT		"Good try. You were a little off-beat, my friend. You won't always be in da crosses, as we say! Remember: press %red% when the shrinking circle turns green."
#define BB_STRING_TUTORIAL_RED_WRONGKEY			"Hmm... that was the wrong key. The Red key is %red%. Press %red% and only %red% to the beat to build the block."
#define BB_STRING_TUTORIAL_BLUE					"The blue key is %blue%. So, this time, hit %blue% on the beat."
#define BB_STRING_TUTORIAL_BLUE_MISSEDBEAT		"Nice try, just a lilly bit off. Try again! Listen closely: press %blue% when the shrinking circle turns green."
#define BB_STRING_TUTORIAL_BLUE_WRONGKEY		"Wrong key, mon, wrong key! The Blue key is %blue%. Hit %blue% on the beat."
#define BB_STRING_TUTORIAL_YELLOW				"The Yellow key is %yellow%. Simply hit %yellow% on the beat."
#define BB_STRING_TUTORIAL_YELLOW_MISSEDBEAT	"So close! Ease up, you know? Relax! Just press %yellow% when the shrinking circle turns green."
#define BB_STRING_TUTORIAL_YELLOW_WRONGKEY		"Are you listening to me? The Yellow key is %yellow%."
#define BB_STRING_TUTORIAL_BUILDINGCOMPLETE		"Great job! Because you pressed the right key to the beat, the block turned red. That is because the true color of this piece was red. You can tell the true color of a piece by looking at the color behind the piece.                            So now let's work on placing pieces on the board, ok? We're going to place this piece with the other red blocks, but first: rotate the board and then the piece so that it fits."
#define BB_STRING_TUTORIAL_ROTATEBOARD			"Let's rotate the board so that the flashing area is at the top of the screen. Use %rotateccw% and %rotatecw% to rotate the flashing area to the top."
#define BB_STRING_TUTORIAL_ROTATEBOARD_RESET	"That is not one of the keys you were told to press. Use %rotateccw% and %rotatecw% to rotate the gap from the lower left to the top."
#define BB_STRING_TUTORIAL_ROTATEPIECE			"You are a lion! Now rotate the piece so that it fills in the gap by pressing %rotatepiece%."
#define BB_STRING_TUTORIAL_ROTATEPIECE_RESET	"That is not one of the keys you were told to press. Press %rotateccw% and %rotatecw% to rotate the gap from the lower left to the top."
#define BB_STRING_TUTORIAL_DROPPIECE			"Ok, star! Now throw the piece by hitting %droppiece%. Ready, mon?"
#define BB_STRING_TUTORIAL_DROPPIECE_RESET		"We need to fill in that gap with the piece. Rotate the gap to the top of the board with %rotateccw% and %rotatecw%. Rotate the piece with %rotatepiece%, and throw the piece with %droppiece%."
#define BB_STRING_TUTORIAL_POWERMOVES			"Nice work, friend! Now we can try a power move. By breaking groups of 10 or more blocks, you perform a power move and swing the crowd in your favor. Note that the more blocks you break, the more damage you do! Let's try one now!"
#define BB_STRING_TUTORIAL_CLEAR				"Press %clear% to perform a power move! Drop legs!"
#define BB_STRING_TUTORIAL_CROWDBAR				"When you bust a move, the crowd arrows will move towards you. When both crowd arrows are pointing at you, you win!"
#define BB_STRING_TUTORIAL_WHITEBLOCKS			"Each power move also adds time to your white block timer. Better moves get you more time, you see? White blocks are wild! They can connect to different colors to make one giant group. Let's try creating one now!"
#define BB_STRING_TUTORIAL_WHITEBLOCKS_BUILD	"Let's build these blocks before the time runs out."
#define BB_STRING_TUTORIAL_WHITEBLOCKS_PLACE	"Ok! Place them so that the wild blocks are touching all three colors."
#define BB_STRING_TUTORIAL_WHITEBLOCKS_CLEAR	"Now break all of the blocks to move on."
#define BB_STRING_TUTORIAL_WHITEBLOCKS_MISSED	"You've almost got this. Don't give up now! Remember: press %red% for Red, press %blue% for Blue, and %yellow% for Yellow."
#define BB_STRING_TUTORIAL_WHITEBLOCKS_TIMEUP	"The white block timer ran out on you. You must complete this piece before the time runs out. To complete this tutorial, you need 3 white Blocks."
#define BB_STRING_TUTORIAL_WHITEBLOCKS_RESET	"Not quite the right spot. Just place the piece, horizontally, such that the center block lands on top of the stack of 3 red blocks."
#define BB_STRING_TUTORIAL_CLEAR_REMINDER		"Just a friendly reminder: the button to clear groups of blocks is %clear%."

#define BB_STRING_BEGINNER	"Beginner"
#define BB_STRING_NOVICE	"Novice"
#define BB_STRING_EXPERT	"Expert"

#define BB_STRING_REFRESH	"Refresh"
#define BB_STRING_STOP		"Stop"

#define BB_STRING_INITLISTENSERVERSELECTSONG	"You must select a song to play before you can create a Server"
#define BB_STRING_FAILEDTOINITSERVER1			"Failed to initialize Listen Server on Port %i. This is generally caused by another program"
#define BB_STRING_FAILEDTOINITSERVER2			"already listening for connections on that port."

#define BB_STRING_MESSAGE			"Message: "
#define BB_STRING_PLAYERNAMEWAITING	"Waiting..."
#define BB_STRING_LOGINFAILED		"Login Failed"
#define BB_STRING_PASSWORDMISMATCH	"Password and Confirm Password don't match"
#define BB_STRING_INVALIDUSERNAME	"The username you have entered is not valid, please enter a"
#define BB_STRING_INVALIDUSERNAME2	"username that is 4 to 20 characters using only numbers and letters"
#define BB_STRING_INVALIDPASSWORD	"The password you have entered is not valid, please enter a"
#define BB_STRING_INVALIDPASSWORD2	"password that is 8 to 32 characters"
#define BB_STRING_INVALIDCDKEY		"The CD-Key you have entered is invalid, please contact us at"
#define BB_STRING_INVALIDCDKEY2		"www.greatergoodgames.org if you need help"
#define BB_STRING_USERNAMETAKEN		"The username you have entered is already taken"
#define BB_STRING_USESTOREDPASSWORD	"$T0REDP@$$"

#define BB_STRING_PREPOPUP_LINE1		"You can disconnect while this is up without taking a loss."
#define BB_STRING_PREPOPUP_SERVERLINE2	"Waiting for an opponent to join."
#define BB_STRING_PREPOPUP_CLICKREADY	"Whenever you are ready to battle, click Ready or press Enter."
#define BB_STRING_PREPOPUP_WAITINGREADY	"Waiting for your opponent to say they're Ready."
#define BB_STRING_PREPOPUP_SERVERQUIT	"The server has disconnected, please click disconnect and find another opponent."

#define BB_STRING_POSTPOPUP_MULTIPLAYERWONLINE1		"Wow, the crowd loved you! Way to bust those moves and put your opponent in his place."
#define BB_STRING_POSTPOPUP_MULTIPLAYERLOSTLINE1	"Good try, but it looks like the crowd just wasn't in your favor today."

#define BB_STRING_POSTPOPUP_CLIENTLINE2				"Your opponent is now choosing the next song, please wait or click disconnect."
#define BB_STRING_POSTPOPUP_CLIENTREMATCHLINE2		"Your opponent has challenged you to a rematch, will you accept?"
#define BB_STRING_POSTPOPUP_CLIENTNEWSONGLINE2		"Your opponent has chosen %s, will you accept the challenge?"
#define BB_STRING_POSTPOPUP_CLIENTSERVERQUITLINE2	"Your opponent has disconnected, please click disconnect and challenge another opponent."

#define BB_STRING_POSTPOPUP_SERVERLINE2				"You can challenge them to a rematch, select a different song, or disconnect."
#define BB_STRING_POSTPOPUP_SERVERWAITING2			"Your request has been sent to your opponent, waiting for them to accept..."
#define BB_STRING_POSTPOPUP_SERVERCLIENTQUITLINE2	"Your opponent has disconnected, but you can still click rematch to play the same song or"
#define BB_STRING_POSTPOPUP_SERVERCLIENTQUITLINE3	"select a new song and wait for a new opponent."

// Static File Paths/Names
#define BB_SETTINGSPATH	"Settings.txt"

#define BB_SCRIPTPATH_PLAYERMOVES	"scripts/PlayerMoves.pes"

#define BB_WINDOW_MENU_INTRO			"MenuGGG"
#define BB_WINDOW_MENU_PROFILE			"MenuProfile"
#define BB_WINDOW_MENU_MAIN				"MenuMain"
#define BB_WINDOW_MENU_UPDATE			"MenuUpdate"
#define BB_WINDOW_MENU_OPTIONS			"MenuOptions"
#define BB_WINDOW_MENU_DIFFICULTY		"MenuDifficulty"
#define BB_WINDOW_MENU_BATTLES			"MenuBattles"
#define BB_WINDOW_MENU_CHALLENGES		"MenuChallenges"
#define BB_WINDOW_MENU_FREEPLAY			"MenuFreePlay"
#define BB_WINDOW_MENU_MESSAGEBOX		"MenuMessageBox"
#define BB_WINDOW_MENU_LOGIN			"MenuLogin"
#define BB_WINDOW_MENU_LOGINSP			"MenuLoginSP"
#define	BB_WINDOW_MENU_REGISTER			"MenuRegister"
#define BB_WINDOW_MENU_LOGGINGIN		"MenuMessageBoxLogin"
#define BB_WINDOW_MENU_MULTIPLAYER		"MenuMultiplayer"
#define BB_WINDOW_MENU_LEADERBOARD		"MenuLeaderboard"
#define BB_WINDOW_MENU_SPLEADERBOARD	"MenuSPLeaderboard"

#define BB_WINDOW_GAMEPAUSED	"GamePaused"

#define BB_WINDOW_MESSAGEBOX					"GameMessageBox"
#define BB_WINDOW_MESSAGEBOX_SERVERPORTWARNING	"GameMessageBoxServerPorts"
#define BB_WINDOW_PREPOPUP						"GamePrePopup"
#define BB_WINDOW_SENSEIPREPOPUP				"GamePrePopupSensei"
#define BB_WINDOW_PREPOPUPSERVER				"GamePrePopupServer"
#define BB_WINDOW_PREPOPUPCLIENT				"GamePrePopupClient"
#define BB_WINDOW_POSTPOPUP						"GamePostPopup"
#define BB_WINDOW_POSTPOPUPFAILED				"GamePostPopupFailed"
#define BB_WINDOW_POSTPOPUPCLIENT				"GamePostPopupClient"
#define BB_WINDOW_POSTPOPUPSERVER				"GamePostPopupServer"
#define BB_WINDOW_SERVERSELECTSONG				"GameServerSelectSong"

#define BB_FONT_VERSUSNAMES			"OldSansBlack-42pt"
#define BB_FONT_SMALL_VERSUSNAMES	"OldSansBlack-30pt"
#define BB_FONT_SONGNAME			"OldSansBlack-22pt"
#define BB_FONT_SCORE				"NumbersOldSansBlack-40pt"
#define BB_FONT_TIMER				"NumbersOldSansBlack-40pt"
#define BB_FONT_NAMES				"OldSansBlack-30pt"
#define BB_FONT_RANK				"Arial14"
#define BB_FONT_TEXTMESSAGES		"Arial14"
#define BB_FONT_COMBO				"Aiiiight-100pt"
#define BB_FONT_BLOCKSCLEARED		"Aiiiight-100pt"
#define BB_FONT_ACHIEVEMENTTITLE	"OldSansBlack-22pt"
#define BB_FONT_TUTKEYS				"OldSansBlack-30pt"

#define BB_NAME_HOVEROBJECT				"Hover"
#define BB_NAME_HOVERTEXTLINE1			"HoverLine1"
#define BB_NAME_HOVERTEXTLINE2			"HoverLine2"
#define BB_NAME_HOVERTEXTLINE3			"HoverLine3"
#define BB_NAME_HOVERTEXTLINE4			"HoverLine4"
#define BB_NAME_MENUOPTIONBG			"OptionBG%s"
#define BB_NAME_MENUOPTIONTEXT			"OptionText%s"
#define BB_NAME_TOURBACKGROUND			"TourBackground"
#define BB_NAME_TOURPERCENTAGETEXT		"TourPercent%i"
#define BB_NAME_TOURTHUMBSUPIMAGE		"TourThumbsUp%i"
#define BB_NAME_TOURDOMINATEDIMAGE		"TourDominated%i"
#define BB_NAME_BATTLEMENUENEMYBG		"BattleBG%i"
#define BB_NAME_BATTLEPERCENTAGETEXT	"CrowdPercent%i"
#define BB_NAME_BATTLETHUMBSUPIMAGE		"ThumbsUp%i"
#define BB_NAME_BATTLEDOMINATEDIMAGE	"Dominated%i"
#define BB_NAME_BATTLEBOSSIMAGE			"Boss%i"
#define BB_NAME_CHALLENGECOMPLETE		"ChallengeComplete%i"
#define BB_NAME_CHALLENGELINE			"ChallengeLine%i"
#define BB_NAME_CHALLENGEACHIEVEMENT	"AchievementIcon"
#define BB_NAME_FREEPLAYSONGBG			"SongBackground%i"
#define BB_NAME_FREEPLAYSONGNAME		"SongName%i"
#define BB_NAME_FREEPLAYARTIST1			"SongArtist1"
#define BB_NAME_FREEPLAYARTIST2			"SongArtist2"
#define BB_NAME_FREEPLAYDIFFSTAR		"SongDifficulty%i-%i"
#define BB_NAME_FREEPLAYDIFFICULTY		"Difficulty%i"
#define BB_NAME_FREEPLAYDIFFICULTYOVER	"DifficultyOver%i"
#define BB_NAME_FREEPLAYEXTRABLOCKS		"ExtraBlocksCheckbox%i"
#define BB_NAME_FREEPLAYENEMYMODEL		"EnemyModel"
#define BB_NAME_BACKBUTTON				"BackButton"
#define BB_NAME_MESSAGEBOXLINEX			"Message%i"
#define BB_NAME_MESSAGEBOXLINE1			"Message1"
#define BB_NAME_MESSAGEBOXLINE2			"Message2"
#define BB_NAME_MESSAGEBOXLINE3			"Message3"
#define BB_NAME_MESSAGEBOXLINE4			"Message4"
#define BB_NAME_MESSAGEBOXLINE5			"Message5"
#define BB_NAME_PREPOPUPMORELINES		"MoreLinesText"
#define BB_NAME_HOSTDIFFICULTY0			"DifficultyToggle0"
#define BB_NAME_HOSTDIFFICULTY1			"DifficultyToggle1"
#define BB_NAME_HOSTDIFFICULTY2			"DifficultyToggle2"
#define BB_NAME_OKBUTTON				"OK"
#define BB_NAME_READYBUTTON				"Ready"
#define BB_NAME_ACCEPTBUTTON			"Accept"
#define BB_NAME_REMATCHBUTTON			"Rematch"
#define BB_NAME_SELECTSONGBUTTON		"SelectSong"
#define	BB_NAME_KICKCLIENTBUTTON		"KickClient"
#define BB_NAME_NEVERSHOWAGAINCHECK		"NeverShowAgain"
#define BB_NAME_RANK					"Rank%i"
#define BB_NAME_PLAYER					"Username%i"
#define BB_NAME_POINTS					"Points%i"
#define BB_NAME_COMPLETION				"Comp%i"
#define BB_NAME_CROWD					"Crowd%i"
#define BB_NAME_TIME					"Time%i"
#define BB_NAME_OPTIONSPANEL			"OptionsPanel%i"
#define BB_NAME_CONTROLSBUTTON			"ControlsButton%i"
#define BB_NAME_CONTROLSALTBUTTON		"ControlsButton%iA"
#define	BB_NAME_RESOLUTIONCOMBO			"ResolutionCombo"
#define BB_NAME_FULLSCREENCHECK			"FullscreenCheckbox"
#define BB_NAME_CHARACTEROUTLINECHECK	"CharacterOutlineCheckbox"
#define BB_NAME_REDUCEDPARTICLESCHECK	"ReducedParticlesCheckbox"
#define BB_NAME_MUSICVOLUMESLIDER		"MusicVolumeSlider"
#define BB_NAME_SOUNDVOLUMESLIDER		"SoundVolumeSlider"
#define BB_NAME_VOICEOVERVOLUMESLIDER	"VoiceOverVolumeSlider"
#define BB_NAME_UPDATEBUTTON			"StartUpdate"
#define BB_NAME_CREDITSBG				"LevelBackground"
#define BB_NAME_CREDITSTEXT				"Credits%i"
#define BB_NAME_CREDITSYOUWIN			"YouWin"
#define BB_NAME_TUTORIALARROW			"TutorialArrow"
#define BB_NAME_PRESSENTER				"PressEnterText"

#define BB_IMAGE_PATH						"images/%s.p2d"
#define BB_VERSUSIMAGE_PATH					"images/VS_%s.p2d"
#define BB_IMAGE_PLAYAREABACKGROUND			"images/Gameboard.p2d"
#define BB_IMAGE_BUILDOVERLAY				"images/BuildOverlay.p2d"
#define BB_IMAGE_BUILDOVERLAYWHITE			"images/BuildOverlayWhite.p2d"
#define BB_IMAGE_COUNTDOWN					"images/Countdown.p2d"
#define BB_IMAGE_BLOCKS						"images/Block_%i.p2d"
#define BB_IMAGE_BLOCKSGLOW					"images/Block_Glow.p2d"
#define BB_IMAGE_BLOCKSOVERLAY				"images/Block_%iOver.p2d"
#define BB_IMAGE_BLOCKSANIMATION			"images/Block_Animation.p2d"
#define BB_IMAGE_BLOCKROTATIONTAIL			"images/FieldBlockRotateTail.p2d"
#define BB_IMAGE_BLOCKPLACETAIL				"images/FieldBlockDropTail.p2d"
#define BB_IMAGE_PIECEBLOCKS				"images/Block_0.p2d"
#define BB_IMAGE_PIECEBLOCKOVERLAY			"images/Block_0Over.p2d"
#define BB_IMAGE_PIECEBLOCKANIMATION		"images/Block_0Animation.p2d"
#define BB_IMAGE_BEATMARKER_DIMMER			"images/BM_Dimmer.p2d"
#define BB_IMAGE_BEATMARKER					"images/BM_Ring.p2d"
#define BB_IMAGE_BEATMARKER_HITZONE			"images/BM_Hitzone.p2d"
#define BB_IMAGE_BUILDARROWUP				"images/Build_Up.p2d"
#define BB_IMAGE_BUILDARROWUPLEFT			"images/Build_UpLeft.p2d"
#define BB_IMAGE_BUILDARROWUPRIGHT			"images/Build_UpRight.p2d"
#define BB_IMAGE_BUILDARROWLEFT				"images/Build_Left.p2d"
#define BB_IMAGE_BUILDARROWRIGHT			"images/Build_Right.p2d"
#define BB_IMAGE_BUILDARROWLEFTRIGHT		"images/Build_LeftRight.p2d"
#define BB_IMAGE_BLOCKPLACEFAILWARNING		"images/BlockFail.p2d"
#define BB_IMAGE_HITTIME					"images/HitTimes.p2d"
#define BB_IMAGE_MULTIPLIERFILL				"images/BlockMultiplierFill.p2d"
#define	BB_IMAGE_WHITEMULTIPLIERFILL		"images/BlockMultiplierFillWhite.p2d"
#define BB_IMAGE_CROWDBARARROW				"images/CrowdBarArrow.p2d"
#define	BB_IMAGE_MULTIPLAYERESCAPEMESSAGE	"images/MultiplayerEscapeMessage.p2d"
#define BB_IMAGE_DIMMER						"images/PauseDimmer.p2d"
#define BB_IMAGE_UPARROWKEY					"images/UpArrow.p2d"
#define BB_IMAGE_DOWNARROWKEY				"images/DownArrow.p2d"
#define BB_IMAGE_LEFTARROWKEY				"images/LeftArrow.p2d"
#define BB_IMAGE_RIGHTARROWKEY				"images/RightArrow.p2d"
#define BB_IMAGE_SPACEBAR					"images/SpaceBar.p2d"
#define BB_IMAGE_BLANKKEY					"images/BlankKey.p2d"
#define BB_IMAGE_ENEMYNAMEBG				"images/NUI_EName.p2d"
#define BB_IMAGE_ENEMYCHARGEBG				"images/NUI_ECharge.p2d"
#define BB_IMAGE_ENEMYCHARGEBAR				"images/NUI_EChargeBar.p2d"
#define BB_IMAGE_ENEMYCHARGEFLASH			"images/NUI_EChargeBarOver.p2d"
#define BB_IMAGE_PLAYERNAMEBG				"images/NUI_PName.p2d"
#define BB_IMAGE_PLAYERCHARGEBG				"images/NUI_PCharge.p2d"
#define BB_IMAGE_PLAYERCHARGEBAR1			"images/NUI_PChageBar1.p2d"
#define BB_IMAGE_PLAYERCHARGEFLASH1			"images/NUI_PChargeBar1Over.p2d"
#define BB_IMAGE_PLAYERCHARGEBAR2			"images/NUI_PChargeBar2.p2d"
#define BB_IMAGE_PLAYERCHARGEFLASH2			"images/NUI_PChargeBar2Over.p2d"
#define BB_IMAGE_PLAYERCHARGEBAR3			"images/NUI_PChargeBar3.p2d"
#define BB_IMAGE_PLAYERCHARGEFLASH3			"images/NUI_PChargeBar3Over.p2d"
#define BB_IMAGE_PLAYERCHARGEBAR4			"images/NUI_PChargeBar4.p2d"
#define BB_IMAGE_PLAYERCHARGEFLASH4			"images/NUI_PChargeBar4Over.p2d"
#define BB_IMAGE_TIMERBG					"images/NUI_Timer.p2d"
#define BB_IMAGE_COMBO						"images/HitsInARow.p2d"
#define BB_IMAGE_BLOCKSCLEARED				"images/Move_BlocksCleared.p2d"
#define BB_IMAGE_BLOCKSCLEAREDDESC			"images/Move_Description.p2d"
#define BB_IMAGE_ACHIEVEMENTBACKGROUND		"images/AchievementBG.p2d"
#define BB_IMAGE_ACHIEVEMENTICON			"images/AchievementIcons.p2d"

#define BB_EMITTER_BLOCKADDED			"images/P_BlockCreate.p2d"
#define BB_EMITTER_BLOCKCLEARED			"images/P_BlockClear.p2d"

#define BB_MUSICPATH_MENU	"music/Menu/Menu.ogg"

#define BB_MUSICDIR_PATH	"music/%s"
#define BB_MUSICFILE_PATH	"music/%s/Song.bbm"
#define BB_MUSICTRACK_PATH	"music/%s/%s.ogg"

#define BB_SOUND_PATH				"sounds/%s"
#define BB_SOUND_VERSUSSCREEN		"sounds/VS_Screen.wav"
#define BB_SOUND_SENSEIPREPOPUP		"sounds/SenseiPrePopup.wav"
#define BB_SOUND_COUNTDOWN1			"sounds/CountdownOne.wav"
#define BB_SOUND_COUNTDOWN2			"sounds/CountdownTwo.wav"
#define BB_SOUND_COUNTDOWN3			"sounds/CountdownThree.wav"
#define BB_SOUND_HITTIME0			"sounds/HitTime0.wav"
#define BB_SOUND_HITTIME1			"sounds/HitTime1.wav"
#define BB_SOUND_HITTIME2			"sounds/HitTime2.wav"
#define BB_SOUND_HITTIME3			"sounds/HitTime3.wav"
#define BB_SOUND_HITTIME4			"sounds/HitTime4.wav"
#define BB_SOUND_HITTIME5			"sounds/HitTime5.wav"
#define BB_SOUND_HITTIME6			"sounds/HitTime6.wav"
#define BB_SOUND_SLIDE				"sounds/Slide.wav"
#define BB_SOUND_ROTATE				"sounds/Rotate.wav"
#define BB_SOUND_DROP				"sounds/Drop.wav"
#define BB_SOUND_TOUCHDOWN			"sounds/TouchDown.wav"
#define BB_SOUND_BLOCKCLEAR			"sounds/LineClear.wav"
#define BB_SOUND_BLOCKCLEARWON		"sounds/LineClearWon.wav"
#define BB_SOUND_SCORELONG			"sounds/ScoreCount.wav"
#define BB_SOUND_UNLOCK				"sounds/Unlocked.wav"
#define BB_SOUND_CROWDLOOP			"sounds/CrowdLoop.wav"
#define BB_SOUND_CROWDLOOPEXCITED	"sounds/CrowdLoopExcited.wav"
#define BB_SOUND_CROWDPOSITIVE		"sounds/CrowdPositive.wav"
#define BB_SOUND_CROWDNEGATIVE		"sounds/CrowdNegative.wav"
#define	BB_SOUND_CROWDGAMEWON		"sounds/CrowdEndGameWin.wav"
#define BB_SOUND_CROWDGAMELOST		"sounds/CrowdEndGameLose.wav"
#define BB_SOUND_PLAYERDANCEMOVE	"sounds/PlayerMoveExecuted.wav"
#define BB_SOUND_ENEMYINTRO			"sounds/%s/Intro.wav"
#define BB_SOUND_ENEMYINTROVOICE	"sounds/%s/IntroVoice.wav"
#define BB_SOUND_ENEMYPREMOVE		"sounds/%s/PreMove.wav"
#define BB_SOUND_ENEMYMOVE			"sounds/%s/SpecialMove.wav"
#define BB_SOUND_ENEMYPOSTMOVE		"sounds/%s/PostMove.wav"
#define BB_SOUND_ENEMYREACTION		"sounds/%s/Reaction.wav"
#define BB_SOUND_WON				"sounds/%s/PWin.wav"
#define BB_SOUND_FAILURE			"sounds/%s/PFail.wav"
#define BB_SOUND_TUTORIALVOICE		"sounds/Sensei/TutorialVoice%i.wav"
#define BB_SOUND_VERSUSSCREEN		"sounds/VS_Screen.wav"
#define BB_SOUND_SENSEIPREPOPUP		"sounds/SenseiPrePopup.wav"
#define BB_SOUND_ENEMYINTRO			"sounds/%s/Intro.wav"
#define BB_SOUND_ENEMYINTROVOICE	"sounds/%s/IntroVoice.wav"
#define BB_SOUND_ENEMYPREMOVE		"sounds/%s/PreMove.wav"
#define BB_SOUND_ENEMYMOVE			"sounds/%s/SpecialMove.wav"
#define BB_SOUND_ENEMYPOSTMOVE		"sounds/%s/PostMove.wav"
#define BB_SOUND_ENEMYREACTION		"sounds/%s/Reaction.wav"

#define BB_ENEMYFILE_PATH	"models/%s/enemy.bbe"
#define BB_ENEMYNAME_WAITING	"Waiting..."

#define BB_FILE_UPDATEBATCH	"UpdateBreakBlocks.bat"
#define BB_FILE_DOWNLOADEXE	"FileDownload.exe"

#define	BB_HTTP_SERVERDOMAIN				"greatergoodgames.org"
#define	BB_HTTP_COMMAND_REGISTER			"GET /gamescript.php?cmd=BreakBlocksRegister&user=%s&pass=%s&key=%s HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define	BB_HTTP_COMMAND_LOGIN				"GET /gamescript.php?cmd=BreakBlocksLogin&user=%s&pass=%s HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define	BB_HTTP_COMMAND_ADDSERVER			"GET /gamescript.php?cmd=BreakBlocksAddServer&port=%i&user=%s&song=%s&diff=%i HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define	BB_HTTP_COMMAND_GETSERVERLIST		"GET /gamescript.php?cmd=BreakBlocksGetServerList HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define	BB_HTTP_COMMAND_REMOVESERVER		"GET /gamescript.php?cmd=BreakBlocksRemoveServer&port=%i&user=%s HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define	BB_HTTP_COMMAND_OPPONENTCONNECTED	"GET /gamescript.php?cmd=BreakBlocksOpponentConnected&port=%i&user=%s&opp=%s HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define	BB_HTTP_COMMAND_BATTLEFINISHED		"GET /gamescript.php?cmd=BreakBlocksBattleFinished&server=%s&port=%i&isserver=%i&user=%s HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define BB_HTTP_COMMAND_GETLEADERBOARDDATA	"GET /gamescript.php?cmd=BreakBlocksLeaderboard&user=%s&list=%i HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define BB_HTTP_COMMAND_UNLOCKACHIEVEMENT	"GET /gamescript.php?cmd=BreakBlocksUnlockAchievement&ach=%s&user=%s&pass=%s HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define BB_HTTP_COMMAND_GETACHIEVEMENTS		"GET /gamescript.php?cmd=BreakBlocksGetAchievements&user=%s HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define BB_HTTP_COMMAND_GETSPLEADERBOARD	"GET /gamescript.php?cmd=BreakBlocksSPLeaderboard&user=%s&diff=%i&list=%i HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#define BB_HTTP_COMMAND_UPDATESPLEADERBOARD	"GET /gamescript.php?cmd=BreakBlocksSPUpdateScore&user=%s&pass=%s&diff=%i&comp=%i&crowd=%i&time=%i HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"

#ifdef FINAL_RELEASE
#define BB_HTTP_COMMAND_UPDATE				"GET /gamescript.php?cmd=BreakBlocksUpdate HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#else
#define BB_HTTP_COMMAND_UPDATE				"GET /gamescript.php?cmd=BreakBlocksUpdateDev HTTP/1.1\r\nHost: www.greatergoodgames.org\r\n\r\n"
#endif

enum xTutorialVoice
{
	BB_TUTVOICE_INTRO,
	BB_TUTVOICE_INTRO2,
	BB_TUTVOICE_RED,
	BB_TUTVOICE_RED_MISSEDBEAT,
	BB_TUTVOICE_RED_WRONGKEY,
	BB_TUTVOICE_BLUE,
	BB_TUTVOICE_BLUE_MISSEDBEAT,
	BB_TUTVOICE_BLUE_WRONGKEY,
	BB_TUTVOICE_YELLOW,
	BB_TUTVOICE_YELLOW_MISSEDBEAT,
	BB_TUTVOICE_YELLOW_WRONGKEY,
	BB_TUTVOICE_BUILDINGCOMPLETE,
	BB_TUTVOICE_BUILDINGCOMPLETE2,
	BB_TUTVOICE_ROTATEBOARD,
	BB_TUTVOICE_ROTATEBOARD_RESET,
	BB_TUTVOICE_ROTATEPIECE,
	BB_TUTVOICE_DROPPIECE,
	BB_TUTVOICE_DROPPIECE_RESET,
	BB_TUTVOICE_POWERMOVES,
	BB_TUTVOICE_CLEAR,
	BB_TUTVOICE_CROWDBAR,
	BB_TUTVOICE_WHITEBLOCKS,
	BB_TUTVOICE_WHITEBLOCKS_BUILD,
	BB_TUTVOICE_WHITEBLOCKS_PLACE,
	BB_TUTVOICE_WHITEBLOCKS_CLEAR,
	BB_TUTVOICE_WHITEBLOCKS_MISSED,
	BB_TUTVOICE_WHITEBLOCKS_TIMEUP,
	BB_TUTVOICE_WHITEBLOCKS_RESET,
	BB_TUTVOICE_CLEAR_REMINDER,
	BB_TUTVOICE_MAX
};

enum xPlayerAnimations
{
	BB_PLAYERANIMATION_INTRO,
	BB_PLAYERANIMATION_IDLE1,
	BB_PLAYERANIMATION_IDLE1ALT,
	BB_PLAYERANIMATION_IDLE2,
	BB_PLAYERANIMATION_IDLE2ALT,
	BB_PLAYERANIMATION_IDLE3,
	BB_PLAYERANIMATION_IDLE3ALT,
	BB_PLAYERANIMATION_IDLE4,
	BB_PLAYERANIMATION_IDLE4ALT,
	BB_PLAYERANIMATION_MOVE1,
	BB_PLAYERANIMATION_MOVE2,
	BB_PLAYERANIMATION_MOVE3,
	BB_PLAYERANIMATION_MOVE4,
	BB_PLAYERANIMATION_MOVE5,
	BB_PLAYERANIMATION_MOVE6,
	BB_PLAYERANIMATION_WON,
	BB_PLAYERANIMATION_LOST,
	BB_PLAYERANIMATION_WONLOOP,
	BB_PLAYERANIMATION_LOSTLOOP,
	BB_PLAYERANIMATION_INTROLOOP,
	BB_PLAYERANIMATION_MAX
};

enum xEnemyAnimations
{
	BB_ENEMYANIMATION_INTRO,
	BB_ENEMYANIMATION_IDLE,
	BB_ENEMYANIMATION_IDLE2,
	BB_ENEMYANIMATION_IDLE3,
	BB_ENEMYANIMATION_IDLE4,
	BB_ENEMYANIMATION_ENEMYMOVE1,
	BB_ENEMYANIMATION_ENEMYMOVE2,
	BB_ENEMYANIMATION_WON,
	BB_ENEMYANIMATION_LOST,
	BB_ENEMYANIMATION_WONLOOP,
	BB_ENEMYANIMATION_LOSTLOOP,
	BB_ENEMYANIMATION_INTROLOOP,
	BB_ENEMYANIMATION_MAX
};

enum xBBAchievements
{
	BB_ACH_NONE,
	BB_ACH_DOMINATE_TRAINING,
	BB_ACH_WIN_SIMPLE,
	BB_ACH_WIN_EASY,
	BB_ACH_WIN_NORMAL,
	BB_ACH_WIN_HARD,
	BB_ACH_WIN_EXPERT,
	BB_ACH_DOMINATE_SIMPLE,
	BB_ACH_DOMINATE_EASY,
	BB_ACH_DOMINATE_NORMAL,
	BB_ACH_DOMINATE_HARD,
	BB_ACH_DOMINATE_EXPERT,
	BB_ACH_COMBO_10,
	BB_ACH_COMBO_100,
	BB_ACH_COMBO_500,
	BB_ACH_COMBO_1000,
	BB_ACH_LEVEL_2_MOVE,
	BB_ACH_LEVEL_3_MOVE,
	BB_ACH_LEVEL_4_MOVE,
	BB_ACH_RINGS_1,
	BB_ACH_RINGS_3,
	BB_ACH_RINGS_6,
	BB_ACH_BLOCKS_200,
	BB_ACH_BLOCKS_250,
	BB_ACH_BLOCKS_300,
	BB_ACH_DOM_1,
	BB_ACH_DOM_2,
	BB_ACH_DOM_3,
	BB_ACH_DOM_4,
	BB_ACH_DOM_5,
	BB_ACH_DOM_6,
	BB_ACHIEVEMENTS_MAX
};

#ifndef FINAL_RELEASE
	#define DEBUG_SHADOW_PIECE	0
	#define DEBUG_CUR_BLOCK		0
	#define DEBUG_TIMER			0
	#define DEBUG_CLEAR_BLOCKS	0
	#define DEBUG_ANIMATION		0
	#define DEBUG_BLOCK_ANIM	0
	#define DEBUG_PIECE_ROTATE	0
	#define DEBUG_VOICE			0
	#define DEBUG_BOSS			1

	extern char g_strTempLog[10240];

	#define	DEBUGSHADOWPIECE(...)	if(DEBUG_SHADOW_PIECE) DEBUGLOG(__VA_ARGS__);
    #define	DEBUGCURBLOCK(...)		if(DEBUG_CUR_BLOCK) DEBUGLOG(__VA_ARGS__);
	#define	DEBUGTIMER(...)			if(DEBUG_TIMER) DEBUGLOG(__VA_ARGS__);
	#define	DEBUGCLEARBLOCKS(...)	if(DEBUG_CLEAR_BLOCKS) DEBUGLOG(__VA_ARGS__);
	#define	DEBUGANIMATION(...)		if(DEBUG_ANIMATION) DEBUGLOG(__VA_ARGS__);
	#define	DEBUGBLOCKANIM(...)		if(DEBUG_BLOCK_ANIM) DEBUGLOG(__VA_ARGS__);
	#define	DEBUGPIECEROTATE(...)	if(DEBUG_PIECE_ROTATE) DEBUGLOG(__VA_ARGS__);
	#define	DEBUGVOICE(...)			if(DEBUG_VOICE) DEBUGLOG(__VA_ARGS__);
    #define	DEBUGBOSS(...)			if(DEBUG_BOSS) DEBUGLOG(__VA_ARGS__);
#else
	#define	DEBUGSHADOWPIECE(x)		NULL
	#define	DEBUGSHADOWPIECE(...)	NULL
	#define	DEBUGCURBLOCK(x)		NULL
	#define	DEBUGCURBLOCK(...)		NULL
	#define	DEBUGTIMER(x)			NULL
	#define	DEBUGTIMER(...)			NULL
	#define	DEBUGCLEARBLOCKS(x)		NULL
	#define	DEBUGCLEARBLOCKS(...)	NULL
	#define	DEBUGANIMATION(x)		NULL
	#define	DEBUGANIMATION(...)		NULL
	#define	DEBUGBLOCKANIM(x)		NULL
	#define	DEBUGBLOCKANIM(...)		NULL
	#define	DEBUGPIECEROTATE(x)		NULL
	#define	DEBUGPIECEROTATE(...)	NULL
	#define	DEBUGVOICE(x)			NULL
	#define	DEBUGVOICE(...)			NULL
	#define	DEBUGBOSS(x)			NULL
	#define	DEBUGBOSS(...)			NULL
#endif

#endif