/////////////////////////////////////////////////////////////////
// Name: xGameState.h
/////////////////////////////////////////////////////////////////
// Description:
// - Serves as a base class for each type of Game State.
/////////////////////////////////////////////////////////////////
// - 7.15.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef XGAMESTATE_H_
#define XGAMESTATE_H_

class xGameState
{
public:
	xGameState() { m_iPreLoadFramesSkipped = 0; }
	virtual bool Init(const char *strFile) = 0;
	virtual bool PreUpdate(DWORD dwTime) = 0;
	virtual bool Update(double dTime) = 0;
	virtual void RefreshAllRenderables() = 0;
	virtual void Shutdown() = 0;

	int m_iPreLoadFramesSkipped;
};

#endif